#!/bin/sh

#This script convert easy-*-amd64.img to bigger  image.

export DLG="<window title=\"EasyResize - Increase\" icon-name=\"gtk-harddisk\">
<vbox>
	<text use-markup=\"true\">
		<label>\"<b>$(gettext 'Resize an EasyOS image file')</b>\"</label>
	</text>
	<text>
		<label>$(gettext 'This tool has only one purpose, to resize an image file to any size you want, then boot it via ventoy as a virtual usb stick.')</label>
	</text>
	<text use-markup=\"true\">
		<label>\"$(gettext 'An example would be a downloaded release of EasyOS, with a name like: ')easy-5.7-amd64.img\"</label>
	</text>
	<frame $(gettext 'File')>
		<text>
			<label>$(gettext 'Drag or paste an image file here') ↓   $(gettext 'Or click the folder icon:')</label>
		</text>
		<hbox>
			<entry accept=\"savefilename\" truncate-multiline=\"true\">
				<default>\"  \"</default>
				<variable>FILE</variable>
			</entry>
			<button>
				<input file stock=\"gtk-open\"></input>
				<variable>FILE_BROWSE_SAVEFILENAME</variable>
				<action function=\"fileselect\">FILE</action>
			</button>
		</hbox>
	</frame>
	<frame $(gettext 'Size')>
		<text>
			<label>$(gettext 'How many MiB to increase')</label>
		</text>
		<entry>
			<default>\"1500\"</default>
			<variable>SIZE</variable>
		</entry>
	</frame>
  	<hbox>
		<button ok><action>exit:ok</action></button>
		<button cancel><action>exit:cancel</action></button>
	</hbox>
</vbox>
</window>"

FILE="../easy-test.img"
sz=$(stat -c "%s" $FILE)
let "sz=sz/1048576"
echo $sz


if [ -t 0 ]; then
	FILE=$(realpath "../easy57/easy-5.7-amd64.img")
	SIZE="800"
else
	RETVARS="`gtkdialog --program=DLG --center`"
	eval "$RETVARS"

	if [ ! -e  "$FILE" ] || [[ ! "$SIZE" =~ ^[1-9][0-9]*$ ]] || [ "$EXIT" == "cancel" ] ; then
		popup "terminate=3  name=notice  level=top|<big>========== Exit ==========</big>"
		exit
	fi
	popup     "terminate=3  name=notice  level=top|<big>Please wait, processing...</big>"

fi
###################################################

path=$(dirname $FILE)
file1=$FILE
file2=${path}/tmp.img
file3=${file1%????}-inc.img

#[ `which pv` ] || cp ../tools/pv /usr/bin/

# copy   the image file
echo -e "\n Copying  the image file... \n"
echo " $file1"
echo " ↓↓↓"
echo " $file2"
echo

#pv $file1 > $file2
cp  $file1   $file2
echo

# resize the image file
echo -e "\n Resizing the image file... \n"
dd if=/dev/zero of=$file2 bs=1M count=${SIZE} conv=notrunc oflag=append status=progress

# mount  the image file to /dev/loopn
loopn=$(losetup -fP --show $file2)

# find   the end (Disk /dev/loop1: 1528MB)(1457MiB)
end=$(parted $loopn print|awk 'NR==2{sub(/..$/,"",$3);print $3}')

# resize the partition
echo -e "\n Resizing the partition... \n"
parted $loopn resizepart 2 $end

# resize the file system
echo -e   " Resizing the file system... \n"
losetup -c ${loopn}
e2fsck -pf ${loopn}p2
echo
resize2fs  ${loopn}p2

# modify the config
echo -e "\n Modifying the image file... \n"

[ -d /tmp/img ] && rm -r /tmp/img
mkdir -p                 /tmp/img/p1
mkdir -p                 /tmp/img/p2

mount ${loopn}p1 /tmp/img/p1
mount ${loopn}p2 /tmp/img/p2
############################
cp -r ../p2/*    /tmp/img/p2/
############################
umount           /tmp/img/p1
umount           /tmp/img/p2

mv $file2 $file3

if [ -t 0 ]; then
	cfdisk   $file3
else
	gparted  $file3
fi

#https://linuxsimply.com/bash-scripting-tutorial/string/
